//
//  AppDelegate.m
//  useTheodoliteCamera
//
//  Created by Craig Hunter on 5/21/18.
//  Copyright © 2018 Hunter. All rights reserved.
//

#import "AppDelegate.h"

@interface AppDelegate ()

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    
    //ask for photo album permission
    
    if ([PHPhotoLibrary authorizationStatus] == PHAuthorizationStatusNotDetermined) {
        [PHPhotoLibrary requestAuthorization:^(PHAuthorizationStatus status) {}];
    }

    // Override point for customization after application launch.
    return YES;
}


- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation {
    
    NSString *actionString = [url host];
    NSString *queryString = [url query];
    
    // Note: we do not thoroughly check the URL for proper content/format/etc here.
    // In real life you should carefully check to make sure the various URL components are correct before proceeding.

    if ([actionString isEqualToString:@"importphoto"]) {
        
        if ([queryString hasPrefix:@"id="]) {
            
            NSArray *paramArray = [queryString componentsSeparatedByString:@"="];

            if ([paramArray count]==2) {
                
                NSString *photoID = [paramArray objectAtIndex:1];
                
                NSArray *photoIDs = [NSArray arrayWithObject:photoID];
                
                PHFetchResult *theAssets = [PHAsset fetchAssetsWithLocalIdentifiers:photoIDs options:nil];
                
                if ([theAssets count]==1) {
                    
                    PHAsset *theAsset = [theAssets objectAtIndex:0];
                    
                    // ========= Here is a way to access the image's metadata as an NSDictionary, and optionally the image as a UIImage
                    
                    [theAsset requestContentEditingInputWithOptions:nil completionHandler:^(PHContentEditingInput *contentEditingInput, NSDictionary *info) {
                        
                        CIImage *fullImage = [CIImage imageWithContentsOfURL:contentEditingInput.fullSizeImageURL];
                        NSDictionary *metadata = fullImage.properties;
                        NSLog(@"%@", metadata);
                        
                        // If desired, can get a UIImage here as follows:
                        //UIImage *theImage = [UIImage imageWithCIImage:fullImage];
                        //[(ViewController*)(_window.rootViewController) displayImage:theImage];
                        
                    }];
                    
                    // ========= And here is a way to directly get the image as a UIImage
                    
                    [[PHImageManager defaultManager] requestImageForAsset:theAsset targetSize:PHImageManagerMaximumSize contentMode:PHImageContentModeDefault options:nil resultHandler:^void(UIImage *theImage, NSDictionary *theDictionary) {
                        [(ViewController*)(_window.rootViewController) displayImage:theImage];
                    }];
                    
                }

            }
        
        
        }
    
    
    }

    
    return YES;
    
}

@end
